import React, {Component} from "react";
import { connect } from "react-redux";
import { ADD_TODO } from './actionTypes';
import { addToDo } from './actions';

class ToDo extends Component {
  
  constructor(props) {
    super(props);
    this.toDoInput = React.createRef();
  }

  handleSubmitToDo = (e) => {
    e.preventDefault();
    
    this.props.addToDo(this.toDoInput.current.value);

    e.target.reset();
  }

  render() {
    return (
      <div>
        <p>You have {this.props.toDos.length} ToDo items.</p>
        <ul>
        {this.props.toDos.map(toDo => <li key={toDo}>{toDo}</li>)}
        </ul>
        <form onSubmit={this.handleSubmitToDo}>
          <input 
            type="text"
            placeholder="enter ToDo item"
            ref={this.toDoInput}
          />
        </form>
      </div>
    )
  }
}

function mapStateToProps(state) {
  return {
    toDos: state.toDos
  };
}

const mapDispatchToProps = {
  addToDo
}

export default connect(mapStateToProps, mapDispatchToProps)(ToDo);
